"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var inversify_1 = require('inversify');
var passport_local_1 = require('passport-local');
var AuthenticationManager = (function () {
    function AuthenticationManager(passport, userManager) {
        this._passport = passport;
        this._userManager = userManager;
    }
    AuthenticationManager.prototype.setupPassport = function () {
        var _this = this;
        this._passport.serializeUser(function (user, done) {
            done(null, user.id);
        });
        this._passport.deserializeUser(function (id, done) {
            done(null, _this._userManager.getModelById(id));
        });
        this._passport.use('local-login', new passport_local_1.Strategy(function (username, password, done) {
            var user = _this._userManager.attemptLogin(username, password);
            if (!user) {
                return done(new Error('Invalid username or password'));
            }
            return done(null, user);
        }));
    };
    AuthenticationManager = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('IPassport')),
        __param(1, inversify_1.inject('IUserManager')), 
        __metadata('design:paramtypes', [Object, Object])
    ], AuthenticationManager);
    return AuthenticationManager;
}());
exports.AuthenticationManager = AuthenticationManager;
