"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var inversify_1 = require('inversify');
var ReviewManager = (function () {
    function ReviewManager(reviewRepository, reviewSerializer) {
        this._reviewRepository = reviewRepository;
        this._reviewSerializer = reviewSerializer;
    }
    ReviewManager.prototype.getAll = function () {
        var _this = this;
        var serialized = [];
        this._reviewRepository.getAll().forEach(function (r) { return serialized.push(_this._reviewSerializer.serialize(r)); });
        return serialized;
    };
    ReviewManager.prototype.getById = function (id) {
        var model = this._reviewRepository.getById(id);
        return this._reviewSerializer.serialize(model);
    };
    ReviewManager = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('IReviewRepository')),
        __param(1, inversify_1.inject('IReviewSerializer')), 
        __metadata('design:paramtypes', [Object, Object])
    ], ReviewManager);
    return ReviewManager;
}());
exports.ReviewManager = ReviewManager;
