"use strict";
require('reflect-metadata');
var express = require('express');
var passport = require('passport');
var cookieParser = require('cookie-parser');
var bodyParser = require('body-parser');
var session = require('express-session');
var inversify_config_1 = require('./inversify.config');
var APP_SECRET = 'somesecretkey';
var APP_PORT = 3000;
var app = express();
app.use(cookieParser());
app.use(bodyParser.json());
app.use(session({
    secret: APP_SECRET,
    saveUninitialized: true,
    resave: false
}));
app.use(function (req, res, next) {
    res.header('Access-Control-Allow-Credentials', 'true');
    res.header('Access-Control-Allow-Origin', req.headers['origin']);
    res.header('Access-Control-Allow-Methods', 'GET,PUT,POST,DELETE');
    res.header('Access-Control-Allow-Headers', 'X-Requested-With, X-HTTP-Method-Override, Content-Type, Accept');
    next();
});
app.use(passport.initialize());
app.use(passport.session());
var serviceManager = inversify_config_1.kernel.get('IServiceManager');
serviceManager.registerRoutes(app);
app.listen(APP_PORT);
console.log('Posiedon is hiding in port ' + APP_PORT);
