"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var inversify_1 = require('inversify');
var AuthenticationService = (function () {
    function AuthenticationService(authenticationManager, passport) {
        this._passport = passport;
        authenticationManager.setupPassport();
    }
    AuthenticationService.prototype.registerRoutes = function (app) {
        app.post('/session', this._authenticationPost.bind(this));
    };
    AuthenticationService.prototype._authenticationPost = function (req, res, next) {
        this._passport.authenticate('local-login', function (err, user, info) {
            if (err) {
                return next(err);
            }
            if (!user) {
                return next(new Error('No user found.'));
            }
            req.logIn(user, function (err) {
                if (err) {
                    return next(err);
                }
                console.log('successful login');
                return res.sendStatus(201);
            });
        })(req, res, next);
    };
    AuthenticationService = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('IAuthenticationManager')),
        __param(1, inversify_1.inject('IPassport')), 
        __metadata('design:paramtypes', [Object, Object])
    ], AuthenticationService);
    return AuthenticationService;
}());
exports.AuthenticationService = AuthenticationService;
