"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var inversify_1 = require('inversify');
var ReviewService = (function () {
    function ReviewService(reviewManager) {
        this._reviewManager = reviewManager;
    }
    ReviewService.prototype.registerRoutes = function (app) {
        app.get('/reviews/', this._getAll.bind(this));
        app.get('/reviews/:id', this._getById.bind(this));
    };
    ReviewService.prototype._getAll = function (req, res) {
        res.send(this._reviewManager.getAll());
    };
    ReviewService.prototype._getById = function (req, res) {
        var requestedId = parseInt(req.params.id, 10);
        res.send(this._reviewManager.getById(requestedId));
    };
    ReviewService = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('IReviewManager')), 
        __metadata('design:paramtypes', [Object])
    ], ReviewService);
    return ReviewService;
}());
exports.ReviewService = ReviewService;
