"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var inversify_1 = require('inversify');
var ServiceManager = (function () {
    function ServiceManager(reviewService, authenticationService, userService, noodleService, brandService) {
        this._containedServices = [
            reviewService,
            authenticationService,
            userService,
            noodleService,
            brandService
        ];
    }
    ServiceManager.prototype.registerRoutes = function (app) {
        this._containedServices.forEach(function (svc) {
            svc.registerRoutes(app);
        });
    };
    ServiceManager = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('IReviewService')),
        __param(1, inversify_1.inject('IAuthenticationService')),
        __param(2, inversify_1.inject('IUserService')),
        __param(3, inversify_1.inject('INoodleService')),
        __param(4, inversify_1.inject('IBrandService')), 
        __metadata('design:paramtypes', [Object, Object, Object, Object, Object])
    ], ServiceManager);
    return ServiceManager;
}());
exports.ServiceManager = ServiceManager;
