"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var inversify_1 = require('inversify');
var UserService = (function () {
    function UserService(userManager) {
        this._userManager = userManager;
    }
    UserService.prototype.registerRoutes = function (app) {
        app.get('/users/current', this._loginCheck.bind(this), this._getCurrent.bind(this));
    };
    UserService.prototype._getCurrent = function (req, res) {
        var id = req.user.id;
        res.send(this._userManager.getById(id));
    };
    UserService.prototype._loginCheck = function (req, res, next) {
        if (req.isAuthenticated() && req.user !== undefined) {
            return next();
        }
        res.sendStatus(401);
    };
    UserService = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('IUserManager')), 
        __metadata('design:paramtypes', [Object])
    ], UserService);
    return UserService;
}());
exports.UserService = UserService;
